%global pkgname rpmkit
%global desctxt \
RpmKit (Rpm toolkit) contains miscellaneous rpm and yum related utilities.

Name:           %{pkgname}
Version:        0.3.1
Release:        1%{?dist}
Summary:        Misc rpm and yum related utilities
Group:          Development/Tools
License:        GPLv3+
URL:            https://github.com/ssato/rpmkit
Source0: %{pkgname}-%{version}.tar.gz
BuildArch:      noarch
BuildRequires:  /usr/bin/pygettext.py
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools

%description    %{desctxt}

%package     -n python3-%{pkgname}
Summary:        %{summary}
Requires:       python3-rpm
Requires:       python3-requests
%{?python_provide:%python_provide python3-%{pkgname}}

%description -n python3-%{pkgname} %{desctxt}

%package     -n python3-%{pkgname}-extras
Summary:        %{summary} - Extra libs
Requires:       python3-%{pkgname} = %{version}-%{release}
Requires:       dnf
Requires:       python3-anyconfig
Requires:       graphviz
Requires:       python3-networkx
Requires:       libosinfo
%{?python_provide:%python_provide python3-%{pkgname}}

%description -n python3-%{pkgname}-extras %{desctxt}
This package provides experimental modules and tools of %{name}.

%prep
%autosetup

%build
%{py3_build}

%install
%{py3_install}

install -d %buildroot/%{_bindir}
for f in tools/*.sh; do install -m 755 $f %buildroot/%{_bindir}/; done

%files       -n python3-%{pkgname}
%doc README.rst
%{_bindir}/buildsrpm
%{_bindir}/rpm2json
%{_bindir}/rpmfy
%{python3_sitelib}/rpmkit*
%{python3_sitelib}/rpmkit/*.py*
%{python3_sitelib}/rpmkit/tests/*.py*
%{python3_sitelib}/rpmkit/updateinfo/*.py*
%{python3_sitelib}/rpmkit/updateinfo/tests/*.py*
#%%{python3_sitelib}/rpmkit/locale/*/LC_MESSAGES/*.mo

%files       -n python3-%{pkgname}-extras
%doc README.rst examples
%{_bindir}/rk-*
%{_bindir}/rpmdb_migrate.sh
%{_datadir}/rpmkit/templates/*.j2
%{_datadir}/rpmkit/templates/css/*
%{_datadir}/rpmkit/templates/js/*
%{python3_sitelib}/rpmkit/extras/*.py*

%changelog
* Sun Nov  3 2019 Satoru SATOH <satoru.satoh@gmail.com> - 0.3.99-1
- Drop modules and command utilizing yum which cannot run with python 3
- Drop modules and command utilizing RHN Classic APIs
- Drop py2 support and switch to py3

* Sat Nov  2 2019 Satoru SATOH <satoru.satoh@gmail.com> - 0.3.0-1
- [depgraph] avoid an error of 'dictionary changed size during iteration'
- [updateinfo] deprecate rpmkit.updateinfo.yumwraper backend
- [yum-surrogate] removed along with rpmkit.updateinfo.yumwraper backend
- [updateinfo] use dnf instead of yum if available
- [updateinfo] implement dnf backend
- [updateinfo] try yum-deprecated before yum by default for yum backend
- remove runtime dependency to rpmkit.updateinfo.subproc and use
  subprocess.Poepn instead
- disable memory profile by default
- utilize setup.cfg and remove dirty hacks in setup.py
- Some other code cleanups and bug fixes

* Fri Jan  9 2015 Satoru SATOH <ssato@redhat.com> - 0.2.14-1
- [swapi] return [] even if an error occurred during API calls
- [extras.updateinfo] refactoring and fixes around CVE/CVSS code
- [updateinfo] do some more analysis in errata
- [updateinfo] do i18n and l10n (ja)
- [updateinfo] enhance inspection of rebuilt and replaced rpms
- Some other code cleanups and bug fixes

* Wed Dec 10 2014 Satoru SATOH <ssato@redhat.com> - 0.2.13-1
- [swapi] make it outputs in valid JSON format to allow post processing w/ jq
- Introduce RHEL_5_BUILD build mode to build this for RHEL 5
- rk-list_errata_for_releases: Add to list errata for RHEL minor releases
- rk-updateinfo{,-legacy}: Replace rk-updateinfo w/ new rpmkit.updateinfo based
  ones along with a few different backends (yumbase, yumwrapper and dnfbase)
  and renamed its old version based on swapi needs RHN or RH Satellite access,
  to rk-updateinfo-legacy
- Clean up and remove some deprecated modules
- Some other code cleanups and bug fixes

* Mon May 26 2014 Satoru SATOH <ssato@redhat.com> - 0.2.11.999-1
- Remove runtime dependency to gevent and implement some alternative routines
  with using multiprocessing module
- Fixed some more PEP8 and pylint errors and warnings
- Some RPM spec cleanups from Kenjiro NAKAYAMA to comply with the latest
  version of Fedora's Packaging guideline
- Switch back to multiprocessing based function to run commands asynchronously
  in rpmkit.shell from rpmkit.shell2.run in rpmkit.extras.depgraph
- Deprecated and removed rpmkit.shell2 module
- Remove runtime dependency to gevent and make use of mulitprocessing based
  functions such like multiprocessing.Pool.map
- Add 'updates' sub command to list update RPMs in rk-fake_yum
- Fix some bugs in the code processing CVEs w/o CVSS metrics in
  rpmkit.extras.updateinfo
- add --nprocs option to control the number of task processes in
  rpmkit.extras.make_rpmdb
- remove the try-except block which catches all errors and hides type mismatch
  error, and process CVEs w/o CVSS metrics correctly in
  rpmkit.extras.updateinfo.get_errata_details()
- Fix a long standing bug in rpmkit.swapi.call() does not process options and
  arguments correctly
- Make use of module specific logger in rpmkit.swapi and rpmkit.identrpm
- Add workaround for the bug that keys not shortened in results in rpmkit.swapi
- Fix logger inialization (add hander) code in rpmkit.swapi and rpmkit.identrpm
- Add new module rpmkit.yum_makelistcache and its configuration example
- Split swapi into sub package (again)
- Add ylc (yum_[make]listcache) sub package to cache updates/errata lists

* Sun Jan 26 2014 Satoru SATOH <ssato@redhat.com> - 0.2.11-1
- Deprecated rpmkit.rpms2sqldb and related tools
- Removed deprecated Bunch module
- Implemented downloads function in rpmkit.extras.list_latest_rpms (but very
  experimental yet)
- Add an experimental script (rpmkit/extras/make_updateinfo_xml.py) to generate
  updateinfo.xml
- I18n-ed and l10n-ed rpmkit.extras.updateinfo as a starting point
- Add worksheet contains the list of RHSAs of which CVSS score >= 4.0 (this is
  one of the PCIDSS requirements) in outputs of rk-updateinfo
- Add an experimental script (rpmkit.extras.compsxml2json) to convert comps.xml
  to JSON file
- Add rpmkit.rpmutils.compute_removed() and its friends to compute removed RPMs
  if given RPMs was uninstalled such like 'yum remove ...' does
- Add a tool called rk-fake_yum to simulate 'yum remove ...', etc.
- Make use of anyconfig to support various output formats in rk-fake_yum
- Add --use-dnf option to use DNF (hawkey/libsolv) as a RPM dependency resolver
  backend to fake_yum
- Deprecated rpmkit.utils.uniq*
- Add pylint checks in tests driver script
- Fixed many PEP8 and pylint errors and warnings

* Wed Dec 11 2013 Satoru SATOH <ssato@redhat.com> - 0.2.10.16-1
- Add a virtual API called swapi.bugzilla.getDetails to rpmkit.swapi to get
  Bugzilla information
- Make bugzilla information related to errata added in errata JSON files by
  rk-updateinfo (rpmkit.extras.updateinfo)
- Add --since option to generate the worksheet to only list errata issued
  later than given date
- Other various enhancements and fixes especially in rk-updateinfo
- Fixed many PEP8 errors and warnings

* Sun Oct 20 2013 Satoru SATOH <satoru.satoh@gmail.com> - 0.2.10.15-1
- Add new command 'rpmfy' and module 'rpmkit.rpmfy' to make [S]RPMs easily

* Fri Jul 26 2013 Satoru SATOH <ssato@redhat.com> - 0.2.10.14-1
- changed internal API of rpmkit.shell2.*(): removed Timeout class and just
  make multiple timeouts passed one by one in args
- Fixed some rpmlint errors and warnings

* Thu Jul 18 2013 Satoru SATOH <ssato@redhat.com> - 0.2.10.13-1
- [buildsrpm] make it run standalone
- [buildsrpm] add --timeout option
- [depgraph] implemented experimental dependency graph, DAG and trees dumping
  functions and CLI frontend for them
- [depgraph] implemented HTML reports generation function
- make rpmkit.memoize.memoize() more robust: check if given arg fn is callable
  and keep docstring of wrapped original function
- Added missing dependency to python-networkx in extras sub-package
- Cleanup this RPM SPEC file

* Mon Jun 24 2013 Satoru SATOH <ssato@redhat.com> - 0.2.10.12-1
- [yum-surrogate] promoted from extras to main
- [yum-surrogate] some fixes around 'Packages' path and root processing
- [yum-surrogate] make root and dist computed automatically if not given
- [yum-surrogate] add new option -L to specify dir to output command log files
- [yum-surrogate] other misc related fixes and enhancements
- [updateinfo] add new command to get update info with using yum-surrogate
- related small fixes and enhancements in rpmkit.rpmutils, etc.
- removed rpmkit.extras.sqlminus

* Fri May 10 2013 Satoru SATOH <ssato@redhat.com> - 0.2.10.11-1
- [yum-surrogate] Add to surrogate running yum on hosts have access to yum
  repos for hosts have no or only partial access to yum repos

* Fri Mar  1 2013 Satoru SATOH <ssato@redhat.com> - 0.2.10.10-1
- [swapi] Implemented experimental support of various output formats w/ tablib

* Fri Dec 14 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.9-1
- [swapi] Fixed bugs to get CVE and CVSS metrics correctly
- [rk-repodata] Fixed module loading path

* Thu Nov  8 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.8-1
- [swapi] Important fixes in configure_with_options

* Wed Nov  7 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.7-1
- [swapi] Various fixes and refactoring, and also added some more test cases

* Fri Oct 19 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.6-1
- [swapi] Fixes around shorten_dict_keynames
- Split into two RPMs

* Tue Aug 21 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.5-1
- Enhancement release including some experimental new modules and commands
- [repodata] new command/module to generate 'resolved' metadata from installation DVDs
- [minifyrpmlist] new command/module to minify given rpms list

* Tue Jun 26 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.4-1
- Enhancement release
- [swapi] new command 'swapi.errata.getAll' to get all errata and CVEs from access.redhat.com

* Mon Jun 25 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.3-1
- Bug fix and enhancement release
- [swapi] new command 'swapi.cve.getAll' to get all CVE data from access.redhat.com
- Handle cases if package don't have "arch" key but have "arch_label" key

* Mon Jun  4 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10.1-1
- Bug fix release
- Fixes and enhancements around rpmkit.shell.do_task by Masatake YAMATO <yamato@redhat.com>

* Sun May 27 2012 Satoru SATOH <ssato@redhat.com> - 0.2.10-1
- New upstream
- Exported myrepo to another package to reduce extra dependencies

* Sun May 20 2012 Satoru SATOH <ssato@redhat.com> - 0.2.9-1
- New upstream
- some updates and fixes in rpmkit.rhncachedb
- fixed some bugs in newly introduced utility routines in rpmkit.rpmutils

* Fri May 18 2012 Satoru SATOH <ssato@redhat.com> - 0.2.8-1
- New upstream
- new module and command, rhncachedb to create cache database of RHN
- added some useful utility routines in rpmkit.rpmutils

* Sat Mar  3 2012 Satoru SATOH <ssato@redhat.com> - 0.2.6.20120303-1
- Switched to multiprocessing module to avoid deadlock in threads

* Wed Feb 29 2012 Satoru SATOH <ssato@redhat.com> - 0.2.6-2
- Fixed a myrepo bug that default template search path list is not set
- Moved some common parts from rpmkit.myrepo.* to rpmkit.{globals,utils}

* Wed Feb 29 2012 Satoru SATOH <ssato@redhat.com> - 0.2.6-1
- New upstream
- Fixed a bug that remote command is not used

* Wed Feb 29 2012 Satoru SATOH <ssato@redhat.com> - 0.2.5-1
- New upstream
- Modularized myrepo and added some testing code for it
- Switched template engine from Cheetah to Tenjin (built-in)

* Thu Nov 17 2011 Satoru SATOH <ssato@redhat.com> - 0.2.4-1
- New upstream
- swapi: started to adding experimental virtual rpcs (swapi.cve.getCvss)
- started to adding test cases separately
- started to checking codes with pep8 command

* Wed Nov  9 2011 Satoru SATOH <ssato@redhat.com> - 0.2.3.20111109-1
- New snapshot release
- swapi: changed scheme to construct caching dir path for each objects to avoid
  too many subdirs made in caching top dir

* Wed Nov  9 2011 Satoru SATOH <ssato@redhat.com> - 0.2.3-1
- New upstream
- swapi: various fixes and enhancements including no online access is needed if
  cache is enough, system cache, read-only cache, pep8 error fixes, etc.

* Thu Sep 15 2011 Satoru SATOH <ssato@redhat.com> - 0.2.2-1
- New upstream
- src/swapi: fixed a grave bug wrongly calls rpmkit.swapi.main()
- swapi: fixed internal API breakage in main()
- identrpm: added --debug option

* Sun Sep 11 2011 Satoru SATOH <ssato@redhat.com> - 0.2.1-1
- Bump version
- identrpm: fixed some bugs in parse_package_label()

* Sat Sep 10 2011 Satoru SATOH <ssato@redhat.com> - 0.2.0.20110910.1-1
- identrpm: added new command to get metadata for given package labels
- fixed some rpmlint errors
- cleaned up some modules not used any more
- swapi: added custom JSON encoder to format date strings in XML-RPC query results
- swapi: make it allow setting cache expiration dates per API

* Wed Aug 24 2011 Satoru SATOH <ssato@redhat.com> - 0.2.0.20110824.1-1
- make _sysconfdir/myrepo.d owned by this package: suggested by yamato@redhat.com

* Thu Aug  4 2011 Satoru SATOH <ssato@redhat.com> - 0.2.0.20110804.1-1
- myrepo: followed updates in packagemaker
- myrepo: added unit / system test driver
- all python code: moved into python_sitelib/rpmkit/ and arranged wrappers for each
- bump up to 0.2.0

* Mon Aug  1 2011 Satoru SATOH <ssato@redhat.com> - 0.1.20110801.1-1
- Initial (static) packaging
